3.11 Version:
o modinfo: Fix crash if module recently deleted from system (Ozan)
o modprobe: Handle built-in modules (Michal)

3.10 Version:
o modprobe: cleanup some option handling (Alan)
o testsuite: Rebuild all the test modules (32/64/be/le) to avoid bitrot

3.9 Version:
o NOTE: tools now fail loudly in the case of non-ELF files being used
o elfops: rename moduleops to elfops, remove struct module from it (Andreas)
o depmod: various symbol lookup and dependency calculation fixes (Andreas)
o doc: various cleanup of man pages (Robby)

3.8 Version:
o doc: Fix build documentation
o zlib: allow dynamic linking (Michal)


3.7 Version:
o NOTE: *** support for pre-2.6 kernels was removed in this version ***
o bindex: modules.order support and fallback in case trie is outdated (Alan)
o depmod: fix is_higher_priority() (Michal)
o depmod: officially disallow specifying modules using relative paths (Alan)
o lib: fix underscore conversion (Alan)
o modprobe: parse empty options correctly
o testsuite: lots of random fixes and cleanups

3.6 Version:
o depmod: make building map files optional (does anyone use them anyway?)
o demod: use shortened path names in index files (relative paths used)
o modprobe: use /sys/module rather than /proc/modules (Andreas)
o modprobe: remove legacy support for pre-2.6 kernels (Andreas)
o modprobe: check that asprintf() calls actually allocate (Andreas)

3.5 Version:
o binary indexing file support (Alan Jenkins)
o depmod: fix some memory leaks, reduce overhead (Alan Jenkins)
o modprobe: fix some memory leaks, reduce overhead (Alan Jenkins)
o rmmod: fix some memory leaks (Alan Jenkins)
o testsuite: update the tests (Alan Jenkins)
o various other fixes

3.4 Version:
o modprobe: add ability to parse kernel command line for module options.

3.3 Version:
o modinfo: add a kernel parameter for info on modules used by other kernels.
o lsmod: modprobe: Comment fixes (thanks Satoru Takeuchi)
o modprobe: don't mangle - in wildcards within [ ] (patch from Sam Morris)
o new mintainer: Jon Masters <jcm@jonmasters.org>
o switch to using git for project maintainance
o misc. memory leakage/build/docs fixes (Luiz Fernando N. Capitulino)
o correct error handling and insmod.static handling (Tobias Stoeckmann)
o various other fixes to build/development process.
	
3.2.2 Version:
o depmod: Try to generate correct input tables for 2.6.14 and above (thanks to report from Scott James Remnant)

3.2.1 Version:
o depmod: macio device support (patch from Jeff Mahoney)

3.2 Version:
o depmod: serio support (patch from Dmitry Torokhov)
o modprobe: Fix load by symbol (thanks to Nathan Lutchansky)
o modinfo: Handle parmtype: for 2.6.11
o depmod: handle other endian (already handle 64 & 32 bit)
o modprobe, rmmod, depmod: check for OOM (patch from Andreas Gruenbacher)
o depmod: don't skip first argument for explicit files (patch from Andrew Snare)
o depmod: handle relative paths in explicit files
o modprobe: load all matching aliases (idea from Dominik Brodowski)
o modprobe: new blacklist keyword (patch from Erik van Konijnenburg)
o CODING: new document describing testsuite
o Makefile: include testsuite inside all source releases
o modprobe: slow down modprobe with gratuitous stat for Reiser4 braindamage (Reported by Gentoo)
o Makefile.am: Use @mandir@, unless it's just prefix/mandir (discussion with Jeremy C. Reed)
o Added $CMDLINE_OPTS substitution to install commands.
o depmod: don't explode on invalid modules (patch from Bill Nottingham)
o modprobe: unlock fd when module already in kernel (either a race, or a rename) (patch from Oliver Blin, reworked)
o modprobe.conf.sgml: docbook2man uses last refentrytitle for output file (fixes endusers needing docbook utils for build)
o modprobe: fix gcc-2.95 compilation by declaring va_list at top of warn() (thanks Rafiq Ismail)
o modprobe: doco fix: -a takes module names, not wildcards.
o depmod, modprobe: gcc 4 signedness warning fixes (thanks to Marco d'Itri)
o modprobe: lock before seeing if module in kernel (might be doing init now!)
o testsuite: use --log-fd (valgrind 3) not --logfile-fd.
o modprobe: spin to avoid parallel load attempts when lock failed.  Fixes "unknown symbols for ehci_hcd" bug with parallel udev on ro root.  (Patch from Pozsar Balazs)

3.1 Version:
o modprobe, rmmod: Fix format string (thanks to Sergey Vlasov)
o modinfo: support -n, and by default display filename.
o modprobe: allow -o with -r to remove renamed modules with deps correct.
o modprobe: fall back to /etc/modprobe.d if fail on /etc/modprobe.conf.
o modprobe: allow config files to be directories, and recurse.
o modprobe: Fix quoting of cmdline options.
o insmod: remove quote handling, since we didn't do it right.
o depmod: ignore symbols (eg. PCI ids) in BSS (patch from Marc Boucher).
o depmod: exit after -h.
o modprobe: file locking on modules to avoid spurious errors if they race (report from Marc Boucher)
o modprobe: Fall back to read-only (no locking) if rw open on module fails
o depmod: updates/ dir overrides (for RH, thanks to Thomas Vander Stichele)
o depmod: don't follow symlinks, broken in updates/ rework (thanks to Marco d'Itri)
o Bashisms removed (thanks to David Weinehall)
o modinfo: use modules.dep, not manual search, so we get updates/ right.
o Fix modinfo manpage missing word (thanks Debian)
o modprobe.devfs: added apm_bios devices (thanks Debian)
o modprobe: don't fatal() on missing includes (thanks Debian)
o modprobe: install/remove commands must override modules.alias file.
o Fix modprobe man page to document --show-depends and install commands (reported by Eric C. Cooper)
o Fix modprobe man page: -t -a removed in 3.0 (report from Thomas Hood)
o Document modprobe.d in modprobe(.conf) man page (report from Stefan Richter)
	
3.0 Version:
o Update missing script (report from Robin Grindley)
o "depmod <version>" implies -a (report from Robin Grindley)
o modprobe: remove -t without -l: it didn't work, so obviously noone was
	using it.
o modprobe: Allow "-a mod1 mod2" (report from Frédéric L. W. Meunier).
o modprobe: Fixed short alloc in merge_args.
o testsuite: run everything under valgrind.
o modprobe: change tabs to spaces in module parameters.
o modprobe: define STT_REGISTER if not defined (report Bill Nottingham)
o modinfo: -p means "parm" not "param" (report from Peter Cordes)
o Rmmod man page description is wrong (report from Pawel)
o modprobe: don't access off end of argv[] when '-c' used.
o depmod: merged Takashi Iwai's isapnp table code (with changes).
o modprobe.conf.sgml: Indicate that command is a shell command.
o rmmod: exit with non-zero on any failure (thanks to Serue Hallyen)
o generate-modprobe.conf: fix up char and block aliases
	(thanks to OGAWA Hirofumi)
o modprobe: Fix warning about passing (and fix that fix thanks to Keith Moore)
o depmod: merged Andrey Borzenkov's input table code (with changes).
o modprobe: install/remove commands can be wildcards, set $MODPROBE_MODULE.
o modprobe: inserting already-inserted is fine, as is removing already-removed.
o modprobe: Add --first-time for old behavior
o generate-modprobe.conf: Use --first-time for above and below commands.
o FAQ: Fix generate-modprobe.conf question (report from Norman Diamond)
o generate-modprobe.conf: Don't complain about common (no longer required) options
o generate-modprobe.conf: Prevent "modprobe.old: command not found" message.
o modprobe: fix semantics of -t to match any dir part (thanks to Paul Whittaker)
o testsuite: test-rmmod/05noproc.sh relies on not being root (thanks to Pierre)
o modprobe: handle infinite recursion caused by already-inserted, where
	dependency has install command but is already installed (thanks to Trond Myklebust)
o configure.in: remove -Wcast-align, gives warnings on IA64 (thanks to
	Andrew Morton). 
o install-with-care: don't hardcode /usr/bin/install (thanks Pierre)
o generate-modprobe.conf: handle "add" lines in modules.conf
o modprobe: -q now only means "silently succeed on unknown modules".
o modprobe: update usage message
o modprobe: flush stdout on verbose, so we always print before children.
o runtests: continue after (optional) test name.
o Makefile.am: moveold checks for already having been run.
o depmod: Handle -C correctly (thanks Richard Hirst)
o Makefile.am: "make check" succeeds if no testcase, or no valgrind.
o depmod: Remove non-working __start and __stop logic, and ignore unknown
	"_GLOBAL_OFFSET_TABLE_" for s390 (patch from Arnd Bergmann)
o modprobe: revert "innocuous change" to skip rest of depends on insertion,
	if this module is already in kernel.  But in a depends on b and c,
	and b is already inserted, we should not skip inserting c!
o configure.in: remove unused $(stat_zlib_flags)
o Makefile.am: build insmod.static properly with --enable-zlib
	(thanks to Andy Wang)
o generate-modprobe.conf: handle "add alias xxx off" correctly
	(thanks to Martin Schlemmer)
o modprobe.c: revert -q behaviour: silent, but exit code 1.
	
0.9.14 Version:
o Don't use syscall macros, use libc wrappers instead
  (patch from Marian Jancar)
o insmod: Allow module from stdin (eg. zcat foo.ko.gz | insmod -).
o depmod: Remove old compat code to recognise ".o" and ".klm" as modules.
o depmod: Implement -A properly (zlib is too slow).
o depmod: zlib support.
o modinfo: zlib support.
o modinfo: handle - vs _ when searching for module.
o modprobe: zlib support.
o modprobe: remove unused fd var (patch from Andrey Borzenkov)
o depmod: fix .ko.gz short names in tables (patch from Andrey Borzenkov)
o configure.in: --moddir (patch from Lucas Correia Villa Real, GoboLinux)
o modprobe: -r with multiple args (as per modutils) (bug from Harald Dunkel)
o modprobe: Make -q ignore unknown modules
o modprobe: Make -q still set exit value (bug from Jamie Lokier).
	
0.9.13 Version:
o generate-modprobe.conf: Add --stdin (patch from Bill Nottingham)
o README: Spelling fix (patch from Alex Goddard)
o modprobe: print options out after modules for --show-depends, and
	prefix with "insmod" (in case we want to show commands later).
o modprobe: make --show-depends show commands (prefix: install).
o Always use syscall() in backwards_compat.c: other archs want it.
o depmod.c: Fix fd leak for deep dirs (patch from Arjan van de Ven)
o modprobe.sgml: document -o/--name option.
o modprobe: include files aliases should override: modprobe.devfs wants this
	so users can override (patch from Martin Schlemmer)
o depmod: fix handling of bad args (reported by Gorik Van Steenberge)
o insmod: do --version/-V
o depmod: fix "all modules are inside loop" corner case
o depmod: Temporary file then move (patch from Andrey Borzenkov).
o generate-modprobe.conf: Added space to PREINSTALL and PREREMOVE
	before semicolon (Patch from Marian Jancar)
o insmod: Backwards compat for insmod.static, too (Thanks to Marian Jancar)
	
0.9.12 Version:
o modprobe.8: Document --set-version (Debian bug #187123, thanks Herbert)
o rmmod.8: Fix raw lsmod(8) references (use proper sgml markup).
o modinfo.c, rmmod.c: Fix includes for when no backwards compat
	(Thanks to Bill Nottingham).
o Makefile.am: lsmod.old symlink from /bin to /sbin in move-old-targets
o depmod: sparc gcc register variable fake undefined fix.
o Makefile.am: Handle Mandrake's .bz2 man pages (Thanks to Paolo Giarrusso)
o depmod: backwards compat at 2.5.48, not 2.5.47 (Thanks to Martin Schimschak)
o depmod: ieee1394 support (Thanks to Ben Collins)
o depmod: updated test suite for ieee1394
o Makefile: make symlink from /sbin/lsmod to /bin/lsmod if that's where we're going.
o modinfo: add manual page.
o modprobe: --show-depends (Asked by Herbert Xu for mkinitrd).
o depmod: Simply and fix loop detection for non-trivial loops
	
0.9.11a Version:
o Makefile: docbook2man fix (Thanks to Terje Rosten)
o Makefile: make install man pages work with autoconf 1.4 (Thanks to Terje Rosten)
	
0.9.11 Version:
o generate-modprobe.conf: Avoid "modprobe version" in stdout.
o generate-modprobe.conf: Fix translation of "options dummy0 -o dummy0"
o modprobe: add --set-version
o modprobe: Add MODPROBE_OPTIONS env. var, and use it to pass some options.
o Fix make moveold: (Thanks to Pavel Roskin, Will Stephenson)
o README: Mention modprobe.devfs for devfs users (Thanks to Pavel Roskin)
o lsmod: belongs in /bin, not /sbin (Thanks to Marco d'Itri)
o Makefile: create man directories (Thanks to John Levon)
o Makefile: no, use normal automake (Thanks v. much to John Levon)
o Makefile: docbook2man tweaks and cleanups (Thanks to Terje Rosten)
o Makefile: include man pages in dist, and clean in maintainer-clean
	(Martin Schlemmer's report).
	
0.9.10 Version:
o modprobe: Remove old .gnu.linkonce.modname renaming code
o modprobe: Add -q flag.
o srpm: install generate-modprobe.conf, too.
o install: move kallsyms and ksyms as well to point to insmod.old
	(Andrew Morton's report)
o generate-modprobe.conf: don't worry about if statements: modprobe -c
	expands them already
o modprobe: Look for __module section as well as
	.gnu.linkonce.this_module in renaming code.
o modprobe: modules.devfsd handling, too (thanks to Martin Schlemmer).
o modprobe.devfs: New file for devfs people.
o modprobe: Handle vermagic in .modinfo section as well as own section.
o depmod: Handle aliases in .modinfo section as well as .modalias section
o Warnings added to build process.
o modinfo: new binary
o modinfo: new testcases
o generate-modprobe.conf: handle missing mktemp
	
0.9.9 Version:
o Install generate-modprobe.conf, too.
o Start an FAQ
o generate-modprobe.conf: use mktemp with an arg (Luuk van der Duim's report)
o Richard Henderson's weak symbol support.
o Anton's .foo == foo support for PPC64.
o --force for removing version information
o generate-modprobe.conf: fix one arg usage (Bug from David van Hoose)
o generate-modprobe.conf: add ; inside { } (from Martin Schlemmer)
o Kai's --force-version patch, modified.
o Zibx Verituse's multiple whitespace in parser patch.
o depmod: Handle strings for GPL in separate section, too.
o lsmod: remove double unistd include (Bug from Dennis Schulz)
o modprobe: Document --force* and -s
	
0.9.8 Version:
o Use docbook2man if docbook-to-man not found (Warren Togami's bug report) 
o Implement -s in modprobe
o If stderr is not open, act as if "--syslog" was given.
o Remove documentation about aliases not overriding real modules.
o Add support for modules.alias and modules.symbols to depmod and modprobe.
o Fix handling of errors in modprobe.conf (Roger Luethi's bug report)
o Petr Vandrovec's __gpl_ksymtab fix.
	
0.9.7 Version:
o Man pages
o modules.conf2modprobe.conf "above" and "below" support.
o Silly typo in filename to modname conversion.
o Double free fix (Marco d'Itri)
o Add --dry-run as synonym for --show everywhere.
o Change backwards compat test to sys_create_module(NULL, 0) != -ENOSYS,
  for people who want /proc/ksyms.
o modules.conf2modprobe.conf renamed to generate-modprobe.conf, uses
  modprobe -c to get built-ins as well.
	
0.9.6 Version:
o Fix aliases using - and _ (thanks to Roger Luethi)
o Audit for more _ - comparisons: canonicalize at input.
o Fix "include overrides alias" bug found during audit.
o Testsuite added
o lsmod ignores trailing (new-style) entries in /proc/modules, and deletes ,.
o message segfault due to reusing varargs fixed.
o Give 0 exit status with --dry-run with wildcards (Roger Luethi's bug report)
o Add --all option (Roger Luethi's bug report)
o Fix double-insert problem caused by symlinks (Roger Luethi's bug report)
o Ignore undefined __start_ and __stop_ as future kernel might.
o Report loops only once.
o Fix complex duplicate elimination handling.
o Implemented --ignore-command in modprobe
o Implemented "remove" in modprobe's modprobe.conf parsing.
o Don't die if /proc/modules can't be opened.
o Modprobe -r checks for in-use modules before trying.
o Warn about lines in modprobe.conf which aren't understood.
o Remove extra spaces in options generated by modprobe.
o Extract 64/32 moduleops into common code.
o Reimplemented wildcard aliases.
o Horrible workaround for devfsd.
o Fix handling of wildcards in modules.conf2modprobe.conf

0.9.5 Version:
o Fix bogus compare code where "modprobe tuner" loaded tun module
  (Thanks to Marco d'Itri's bug report).
o Handle rth-style modules in modprobe namechange code.
o Marco d'Itri's patch to correct quotes
o Marco d'Itri's patch to implement -A.
o Fixed rmmod's message when no unload support.
o Fix backwards compat recursion protection to compare PIDs (Petr Vandrovec)
o Implement -F and -e.
o Tweak message when invalid parameter given (Roger Luethi's report)
	
0.9.4 Version
o Implement loop detection and duplicate elimination (thanks to Jeff
  Chua's ide.ko / ide-io.ko bug report)
o Fix stress_modules.sh script for new names and dir layout
o Updated README to put autoconf at the bottom (most people don't need it)
o Implemented -v in depmod
o Implemented -l and -t in modprobe.
o Implemented -a in modprobe.
o Removed gratuitous configure.in target test (we do 64/32 dynamically)
o Adam Richter's depmod patch to traverse above kernel/ dir.
o Fix -r to be properly ignored (Chris Cheney's bug report)

0.9.3 Version
o Fix modprobe -r ordering (tried to remove backwards) (Jim Radford's report)
o David Brownell's extra rmmod options (modified)

0.9.2 Version
o Matthieu Verbert <mve@zurich.ibm.com>'s objdir != srcdir install fix.
o Fixed insmod option ignores (Petr Vandrovec's bug report)
o Arnd Bergmann <arnd@bergmann-dalldorf.de>'s modules.ccwmap implementation.
o Jim Radford <radford@blackbean.org>'s modprobe -r implementation.
	
0.9.1 Version
o Include install-with-care script in dist

0.9 Version
o Added install-with-care script to check we're not destroying old utils
o Split moveold into two targets for gentoo
o Don't use readlink in moveold: RH8.0 doesn't have it by default
o Fix ia64 _syscall5 problem (undefined reference to `__ia64_syscall')
	
0.9-alpha Version
o Fixed patch in NEWS to leave #include linux/elf.h, needed for
  CONFIG_KALLSYMS.
o Fixed extra newline in "in use by" message.
o Fixed parsing for new-style /proc/modules.
o Fixed version parsing code (thanks to Adam Richter's report)
o Fixed "running out of filedescriptors" (Adam Richter)	
o Implemented options in modprobe
o Implemented install in modprobe
o Implemented options in modules.conf2modprobe.conf
o Implemented install in modules.conf2modprobe.conf
o Implemented probeall in modules.conf2modprobe.conf
o Implemented probe in modules.conf2modprobe.conf
o Changed modprobe version to be constant string, for "strings" to work easily.
	
0.8a Version
o Fixed erroneous warning on rmmod saying it didn't find module in
  /proc/modules
	
0.8 Version
o Chris Cheney's automake patch
o Adam J. Richter's "use depmod" patch (simplifies aliases, handles include)
o Cleaned up error handling a little
o Implemented --name/-o to change module name (requires Kai's modname patch)
o David Hardeman's dummy options patch for Debian.
o Updated version number (thanks to David Hardeman).
o Fix "sbin not in path" .old exec problem.
o Remove assumptions about module extension.
o Added "links" and "moveold" targets, and leave using them to the user.
o Implemented new depmod which works with current kernels, calls old
  one for previous kernels.
o First cut of modules.conf2modprobe.conf
o Implemented dummy insmod -p, -s and -f options, requested by Petr Vandrovec

0.7a Version
o 64/32 bit autodetection thanks to Dave Miller
o Preliminary alias support.
o Very primitive /etc/modprobe.conf support
o Fix for "rmmod ide-cd" (bug from Jens Axboe)
o Options args for modprobe
